import pygame, sys, os, math
from pygame.locals import *
import matplotlib.pyplot as plt

def rotate_player_to_angle_and_translate(arena,player_image, angle,curPosX,curPosY):
    """rotate a Surface, maintaining position."""
    rot_sprite = pygame.transform.rotozoom(player_image, angle,1) #This rotates an image around angle degrees
    rect = rot_sprite.get_rect(center=(curPosX,curPosY)) #This centers the rotated image on its old position
    arena.blit(rot_sprite, rect) #Updates the screen
    return rot_sprite
    

#Initial Position and Rotation of the Player
#Change these during the loop to update the players Position    
player_pos_x = 50 
player_pos_y = 300
playerHeading = 0

player_positions_x = [60,70,80,90,100,120,140,160,180,200,230,260,290,300,310,320,330,360,410,390,350,330,330,340,350,370,390,410,440,480,520,550,600,650,670,690,700,710,720,720,720]

pygame.init() #Initialize the pygame module
screen = pygame.display.set_mode((800, 600)) #Define a 800,600 screen

player_original = pygame.image.load(os.path.join("braitenberg.png")) #Load the braitenberg image. It has to be located in the same folder as this script!
player_original.convert() #This function converts the loaded image to game sprite

for pos_x in player_positions_x: #The pygame Loop runs for all position commands
    for event in pygame.event.get(): #This loop makes sure that the X-Button works!
            if event.type == QUIT:
                pygame.quit() #Quit the game in case of x-button press
                sys.exit()


    screen.fill((255,255,255)) # In each loop we will redraw the screen with white color


    playerHeading = 0 #The heading stays the same for now
    
    player_pos_x = pos_x  #Change the positions to the position specified in the list
    player_pos_y = player_pos_y
    
    #These two functions apply the calculated rotation and translation of the player
    rotate_player_to_angle_and_translate(screen,player_original,playerHeading,player_pos_x,player_pos_y)
        
		
    pygame.display.flip() # This shows all the updates
    pygame.time.delay(40) #This puts a delay between each loop iteration

############## HOW FAST WAS THE PLAYER?
############## USE NUMERICAL DIFFERENTIATION TO CALCULATE A LIST OF VELOCITIES
player_velocities_x = [0] ### Append all velocities to this list

##The list of positions is found in the list: player_positions_x 
for i in range(1,len(player_positions_x)): #Start from the second element because we always look at i-1
    velocity = player_positions_x[i] - player_positions_x[i-1] #Velocity is the difference between positions
    player_velocities_x.append(velocity) #Append the velocity to our list    


### At the end we plot the positions # If you are done you may add your velocity plot 
f,(ax1,ax2) = plt.subplots(2,1) ##This is just an example how you can put multiple plots in one picture
#ax1 and ax2 are the subplots and (2,1) states that both plots will be on top of each other. (1,2) would put them side by side

ax1.plot(player_positions_x) #Tell the subplot which data to plot
ax1.set_ylabel('x - position') #The function is called set_ylabel for subplots
#ax1.xlabel('time steps')
ax1.set_title('The Braitenberg\'s Position')

ax2.plot(player_velocities_x)
ax2.set_ylabel('x - velocity')
ax2.set_xlabel('time steps')
ax2.set_title('The Braitenberg\'s Velocity')
plt.tight_layout() #This function is necessary to avoid overlaps between titles and labels
plt.show() #This presents the plot to the user
    
pygame.quit()